using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.GlobalHelper;
using CMS.DataEngine;
using CMS.CMSHelper;
using CMS.UIControls;

public partial class CMSAdminControls_Debug_CacheLog : CacheLog
{
    protected string cmsVersion = null;
    protected int index = 0;


    protected void Page_Load(object sender, EventArgs e)
    {
        this.EnableViewState = false;
        this.Visible = true;
    }


    protected override void OnPreRender(EventArgs e)
    {
        base.OnPreRender(e);

        this.Visible = false;

        if (!DataHelper.DataSourceIsEmpty(this.CacheTable))
        {
            this.Visible = true;

            cmsVersion = ResHelper.GetString("Footer.Version") + "&nbsp;" + CMSContext.SYSTEM_VERSION + "&nbsp;" + ResHelper.GetString("Footer.Build") + "&nbsp;" + CMSContext.FullSystemVersion;

            gridCache.Columns[1].HeaderText = ResHelper.GetString("CacheLog.Operation");
            gridCache.Columns[2].HeaderText = ResHelper.GetString("CacheLog.Data");
            gridCache.Columns[3].HeaderText = ResHelper.GetString("CacheLog.Context");

            if (LogStyle != "")
            {
                this.ltlInfo.Text = "<div style=\"padding: 2px; font-weight: bold; background-color: #eecccc; border-bottom: solid 1px #ff0000;\">" + ResHelper.GetString("CacheLog.Info") + "</div>";
            }

            gridCache.DataSource = this.CacheTable;
            gridCache.DataBind();
        }
    }


    protected int GetIndex()
    {
        return ++index;
    }
}
