using System;

using CMS.GlobalHelper;
using CMS.SettingsProvider;
using CMS.CMSHelper;
using CMS.SiteProvider;
using CMS.UIControls;
using CMS.LicenseProvider;

public partial class CMSDesk_Content_Properties_header : CMSDeskPage
{
    protected void Page_Load(object sender, EventArgs e)
    {
        int selectedTab = -1;
        bool selecting = true;

        bool personalize = SettingsKeyProvider.GetBoolValue(CMSContext.CurrentSiteName + ".CMSPersonalizeUserInterface");
        CurrentUserInfo curUser = CMSContext.CurrentUser;

        int nodeid = QueryHelper.GetInteger("nodeid", 0);
        int index = 0;

        // Get wanted property tab
        string wanted = DataHelper.GetNotEmpty(QueryHelper.GetString("tab", String.Empty).ToLower(), PropertyTabCode.ToString(UIContext.PropertyTab));

        // Get whether to display tab
        bool generalTab = (personalize && (curUser.IsAuthorizedPerResource("CMS.UserInterface", "PropertiesGeneral"))) || !personalize;
        bool urlsTab = (personalize && (curUser.IsAuthorizedPerResource("CMS.UserInterface", "PropertiesUrls"))) || !personalize;
        bool templateTab = (personalize && (curUser.IsAuthorizedPerResource("CMS.UserInterface", "PropertiesTemplate"))) || !personalize;
        bool metadataTab = (personalize && (curUser.IsAuthorizedPerResource("CMS.UserInterface", "PropertiesMetaData"))) || !personalize;
        bool categoriesTab = (personalize && (curUser.IsAuthorizedPerResource("CMS.UserInterface", "PropertiesCategories"))) || !personalize;
        bool menuTab = (personalize && (curUser.IsAuthorizedPerResource("CMS.UserInterface", "PropertiesMenu"))) || !personalize;
        bool workflowTab = (personalize && (curUser.IsAuthorizedPerResource("CMS.UserInterface", "PropertiesWorkflow"))) || !personalize;
        bool versionsTab = (personalize && (curUser.IsAuthorizedPerResource("CMS.UserInterface", "PropertiesVersions"))) || !personalize;
        bool relatedDocumentsTab = (personalize && (curUser.IsAuthorizedPerResource("CMS.UserInterface", "PropertiesRelatedDocs"))) || !personalize;
        bool linkedDocumentsTab = (personalize && (curUser.IsAuthorizedPerResource("CMS.UserInterface", "PropertiesLinkedDocs"))) || !personalize;
        bool securityTab = (personalize && (curUser.IsAuthorizedPerResource("CMS.UserInterface", "PropertiesSecurity"))) || !personalize;
        bool attachmentsTab = (personalize && (curUser.IsAuthorizedPerResource("CMS.UserInterface", "PropertiesAttachments"))) || !personalize;
        bool languagesTab = ((personalize && (curUser.IsAuthorizedPerResource("CMS.UserInterface", "PropertiesLanguages"))) || !personalize) && (CultureInfoProvider.IsSiteMultilignual(CMSContext.CurrentSiteName)) && LicenseHelper.CheckFeature(UrlHelper.GetCurrentDomain(), FeatureEnum.Multilingual);

        int tabCount = 0;

        if (generalTab)
        {
            tabCount++;
        }
        if (urlsTab)
        {
            tabCount++;
        }
        if (templateTab)
        {
            tabCount++;
        }
        if (metadataTab)
        {
            tabCount++;
        }
        if (categoriesTab)
        {
            tabCount++;
        }
        if (menuTab)
        {
            tabCount++;
        }
        if (workflowTab)
        {
            tabCount++;
        }
        if (versionsTab)
        {
            tabCount++;
        }
        if (relatedDocumentsTab)
        {
            tabCount++;
        }
        if (linkedDocumentsTab)
        {
            tabCount++;
        }
        if (securityTab)
        {
            tabCount++;
        }
        if (attachmentsTab)
        {
            tabCount++;
        }
        if (languagesTab)
        {
            tabCount++;
        }
        string[,] tabs = new string[tabCount, 4];

        // General
        if (generalTab)
        {
            tabs[index, 0] = "&nbsp;" + ResHelper.GetString("general.general") + "&nbsp;";
            tabs[index, 2] = "general.aspx?nodeid=" + nodeid;
            selectedTab = index;
            if (wanted == "general")
            {
                selecting = false;
            }
            index++;
        }

        // URLs
        if (urlsTab)
        {
            tabs[index, 0] = "&nbsp;" + ResHelper.GetString("Properties.Urls") + "&nbsp;";
            tabs[index, 2] = "Alias_List.aspx?nodeid=" + nodeid;
            if (selecting)
            {
                selectedTab = index;
            }
            if (wanted == "urls")
            {
                selecting = false;
            }
            index++;
        }

        // Template
        if (templateTab)
        {
            tabs[index, 0] = "&nbsp;" + ResHelper.GetString("Properties.Template") + "&nbsp;";
            tabs[index, 2] = "template.aspx?nodeid=" + nodeid;
            if (selecting)
            {
                selectedTab = index;
            }
            if (wanted == "template")
            {
                selecting = false;
            }
            index++;
        }

        // Metadata
        if (metadataTab)
        {
            tabs[index, 0] = "&nbsp;" + ResHelper.GetString("Properties.Metadata") + "&nbsp;";
            tabs[index, 2] = "metadata.aspx?nodeid=" + nodeid;
            if (selecting)
            {
                selectedTab = index;
            }
            if (wanted == "metadata")
            {
                selecting = false;
            }
            index++;
        }

        // Categories
        if (categoriesTab)
        {
            tabs[index, 0] = "&nbsp;" + ResHelper.GetString("Properties.Categories") + "&nbsp;";
            tabs[index, 2] = "Categories.aspx?nodeid=" + nodeid;
            if (selecting)
            {
                selectedTab = index;
            }
            if (wanted == "categories")
            {
                selecting = false;
            }
            index++;
        }

        // Menu
        if (menuTab)
        {
            tabs[index, 0] = "&nbsp;" + ResHelper.GetString("Properties.Menu") + "&nbsp;";
            tabs[index, 2] = "menu.aspx?nodeid=" + nodeid;
            if (selecting)
            {
                selectedTab = index;
            }
            if (wanted == "menu")
            {
                selecting = false;
            }
            index++;
        }

        // Workflow
        if (workflowTab)
        {
            tabs[index, 0] = "&nbsp;" + ResHelper.GetString("Properties.Workflow") + "&nbsp;";
            tabs[index, 2] = "workflow.aspx?nodeid=" + nodeid;
            if (selecting)
            {
                selectedTab = index;
            }
            if (wanted == "workflow")
            {
                selecting = false;
            }
            index++;
        }

        // Versions
        if (versionsTab)
        {
            tabs[index, 0] = "&nbsp;" + ResHelper.GetString("Properties.Versions") + "&nbsp;";
            tabs[index, 2] = "versions.aspx?nodeid=" + nodeid;
            if (selecting)
            {
                selectedTab = index;
            }
            if (wanted == "versions")
            {
                selecting = false;
            }
            index++;
        }

        // Related documents
        if (relatedDocumentsTab)
        {
            tabs[index, 0] = "&nbsp;" + ResHelper.GetString("Properties.Related") + "&nbsp;";
            tabs[index, 2] = "Relateddocs_List.aspx?nodeid=" + nodeid;
            if (selecting)
            {
                selectedTab = index;
            }
            if (wanted == "related")
            {
                selecting = false;
            }
            index++;
        }

        // Linked documents
        if (linkedDocumentsTab)
        {
            tabs[index, 0] = "&nbsp;" + ResHelper.GetString("Properties.Linked") + "&nbsp;";
            tabs[index, 2] = "LinkedDocs.aspx?nodeid=" + nodeid;
            if (selecting)
            {
                selectedTab = index;
            }
            if (wanted == "linked")
            {
                selecting = false;
            }
            index++;
        }

        // Security
        if (securityTab)
        {
            tabs[index, 0] = "&nbsp;" + ResHelper.GetString("Properties.Security") + "&nbsp;";
            tabs[index, 2] = "security.aspx?nodeid=" + nodeid;
            if (selecting)
            {
                selectedTab = index;
            }
            if (wanted == "security")
            {
                selecting = false;
            }
            index++;
        }

        // Attachments
        if (attachmentsTab)
        {
            tabs[index, 0] = "&nbsp;" + ResHelper.GetString("Properties.Attachments") + "&nbsp;";
            tabs[index, 2] = "attachments.aspx?nodeid=" + nodeid;
            if (selecting)
            {
                selectedTab = index;
            }
            if (wanted == "attachments")
            {
                selecting = false;
            }
            index++;
        }

        // Languages
        if (languagesTab)
        {
            tabs[index, 0] = "&nbsp;" + ResHelper.GetString("Properties.Languages") + "&nbsp;";
            tabs[index, 2] = "languages.aspx?nodeid=" + nodeid;
            if (selecting)
            {
                selectedTab = index;
            }
            if (wanted == "languages")
            {
                selecting = false;
            }
            index++;
        }

        CurrentMaster.Tabs.Tabs = tabs;
        CurrentMaster.Tabs.SelectedTab = selectedTab;
        CurrentMaster.Tabs.UrlTarget = "propedit";
        CurrentMaster.SetRTL();
    }
}
