using System;
using System.Data;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Text;
using System.IO;

using CMS.PortalControls;
using CMS.GlobalHelper;
using CMS.CMSHelper;
using CMS.PortalEngine;

public partial class CMSWebParts_GoogleServices_GoogleMaps : CMSAbstractWebPart
{
    #region "Variables"

    private bool? mDetailMode = null;
    private bool loadScripts = true;
    private string mKey = "";
    private string outputHtml = "";

    #endregion


    #region "Document properties"

    /// <summary>
    /// Cache item name
    /// </summary>
    public override string CacheItemName
    {
        get
        {
            return base.CacheItemName;
        }
        set
        {
            base.CacheItemName = value;
            repItems.CacheItemName = value;
        }
    }


    /// <summary>
    /// Cache dependencies, each cache dependency on a new line
    /// </summary>
    public override string CacheDependencies
    {
        get
        {
            return ValidationHelper.GetString(base.CacheDependencies, repItems.CacheDependencies);
        }
        set
        {
            base.CacheDependencies = value;
            repItems.CacheDependencies = value;
        }
    }


    /// <summary>
    /// Cache minutes
    /// </summary>
    public override int CacheMinutes
    {
        get
        {
            return base.CacheMinutes;
        }
        set
        {
            base.CacheMinutes = value;
            repItems.CacheMinutes = value;
        }
    }


    /// <summary>
    /// Check permissions
    /// </summary>
    public bool CheckPermissions
    {
        get
        {
            return ValidationHelper.GetBoolean(GetValue("CheckPermissions"), repItems.CheckPermissions);
        }
        set
        {
            SetValue("CheckPermissions", value);
        }
    }


    /// <summary>
    /// Class names
    /// </summary>
    public string ClassNames
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(GetValue("Classnames"), repItems.ClassNames), repItems.ClassNames);
        }
        set
        {
            SetValue("ClassNames", value);
            repItems.ClassNames = value;
        }
    }


    /// <summary>
    /// Combine with default culture
    /// </summary>
    public bool CombineWithDefaultCulture
    {
        get
        {
            return ValidationHelper.GetBoolean(GetValue("CombineWithDefaultCulture"), repItems.CombineWithDefaultCulture);
        }
        set
        {
            SetValue("CombineWithDefaultCulture", value);
            repItems.CombineWithDefaultCulture = value;
        }
    }


    /// <summary>
    /// Filter out duplicate documents
    /// </summary>
    public bool FilterOutDuplicates
    {
        get
        {
            return ValidationHelper.GetBoolean(GetValue("FilterOutDuplicates"), repItems.FilterOutDuplicates);
        }
        set
        {
            SetValue("FilterOutDuplicates", value);
            repItems.FilterOutDuplicates = value;
        }
    }


    /// <summary>
    /// Culture code
    /// </summary>
    public string CultureCode
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(GetValue("CultureCode"), repItems.CultureCode), repItems.CultureCode);
        }
        set
        {
            SetValue("CultureCode", value);
            repItems.CultureCode = value;
        }
    }


    /// <summary>
    /// Maximal relative level
    /// </summary>
    public int MaxRelativeLevel
    {
        get
        {
            return ValidationHelper.GetInteger(GetValue("MaxRelativeLevel"), repItems.MaxRelativeLevel);
        }
        set
        {
            SetValue("MaxRelativeLevel", value);
            repItems.MaxRelativeLevel = value;
        }
    }


    /// <summary>
    /// Order by clause
    /// </summary>
    public string OrderBy
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(GetValue("OrderBy"), repItems.OrderBy), repItems.OrderBy);
        }
        set
        {
            SetValue("OrderBy", value);
            repItems.OrderBy = value;
        }
    }


    /// <summary>
    /// Nodes path 
    /// </summary>
    public string Path
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(GetValue("Path"), null), null);
        }
        set
        {
            SetValue("Path", value);
            repItems.Path = value;
        }
    }


    /// <summary>
    /// Select only published nodes
    /// </summary>
    public bool SelectOnlyPublished
    {
        get
        {
            return ValidationHelper.GetBoolean(GetValue("SelectOnlyPublished"), repItems.SelectOnlyPublished);
        }
        set
        {
            SetValue("SelectOnlyPublished", value);
            repItems.SelectOnlyPublished = value;
        }
    }


    /// <summary>
    /// Site name
    /// </summary>
    public string SiteName
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(GetValue("SiteName"), repItems.SiteName), repItems.SiteName);
        }
        set
        {
            SetValue("SiteName", value);
            repItems.SiteName = value;
        }
    }


    /// <summary>
    /// Where condition
    /// </summary>
    public string WhereCondition
    {
        get
        {
            return DataHelper.GetNotEmpty(GetValue("WhereCondition"), repItems.WhereCondition);
        }
        set
        {
            SetValue("WhereCondition", value);
            repItems.WhereCondition = value;
        }
    }


    /// <summary>
    /// Select top N items
    /// </summary>
    public int SelectTopN
    {
        get
        {
            return ValidationHelper.GetInteger(GetValue("SelectTopN"), repItems.SelectTopN);
        }
        set
        {
            SetValue("SelectTopN", value);
            repItems.SelectTopN = value;
        }
    }

    #endregion


    #region "Relationships properties"

    /// <summary>
    /// Related node is on the left side
    /// </summary>
    public bool RelatedNodeIsOnTheLeftSide
    {
        get
        {
            return ValidationHelper.GetBoolean(GetValue("RelatedNodeIsOnTheLeftSide"), repItems.RelatedNodeIsOnTheLeftSide);
        }
        set
        {
            SetValue("RelatedNodeIsOnTheLeftSide", value);
            repItems.RelatedNodeIsOnTheLeftSide = value;
        }
    }


    /// <summary>
    /// Relationship name
    /// </summary>
    public string RelationshipName
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(GetValue("RelationshipName"), repItems.RelationshipName), repItems.RelationshipName);
        }
        set
        {
            SetValue("RelationshipName", value);
            repItems.RelationshipName = value;
        }
    }


    /// <summary>
    /// Relationship with node GUID
    /// </summary>
    public Guid RelationshipWithNodeGUID
    {
        get
        {
            return ValidationHelper.GetGuid(GetValue("RelationshipWithNodeGuid"), repItems.RelationshipWithNodeGuid);
        }
        set
        {
            SetValue("RelationshipWithNodeGuid", value);
            repItems.RelationshipWithNodeGuid = value;
        }
    }

    #endregion


    #region "Transformation properties"

    /// <summary>
    /// Gets or sets the name of the transforamtion which is used for displaying the results
    /// </summary>
    public string TransformationName
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(GetValue("TransformationName"), repItems.TransformationName), repItems.TransformationName);
        }
        set
        {
            SetValue("TransformationName", value);
            repItems.TransformationName = value;
        }
    }


    /// <summary>
    /// Transformation name
    /// </summary>
    public string AlternatingTransformationName
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(GetValue("AlternatingTransformationName"), repItems.AlternatingTransformationName), repItems.AlternatingTransformationName);
        }
        set
        {
            SetValue("AlternatingTransformationName", value);
            repItems.AlternatingTransformationName = value;
        }
    }

    #endregion


    #region "Public properties"

    /// <summary>
    /// Gets or sets the nested controls IDs. Use ';' like separator.
    /// </summary>
    public string NestedControlsID
    {
        get
        {
            return ValidationHelper.GetString(GetValue("NestedControlsID"), repItems.NestedControlsID);
        }
        set
        {
            SetValue("NestedControlsID", value);
            repItems.NestedControlsID = value;
        }
    }


    /// <summary>
    /// Hide control for zero rows
    /// </summary>
    public bool HideControlForZeroRows
    {
        get
        {
            return ValidationHelper.GetBoolean(GetValue("HideControlForZeroRows"), repItems.HideControlForZeroRows);
        }
        set
        {
            SetValue("HideControlForZeroRows", value);
            repItems.HideControlForZeroRows = value;
        }
    }


    /// <summary>
    /// Zero rows text
    /// </summary>
    public string ZeroRowsText
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(GetValue("ZeroRowsText"), repItems.ZeroRowsText), repItems.ZeroRowsText);
        }
        set
        {
            SetValue("ZeroRowsText", value);
            repItems.ZeroRowsText = value;
        }
    }


    /// <summary>
    /// Item separator
    /// </summary>
    public string ItemSeparator
    {
        get
        {
            return DataHelper.GetNotEmpty(GetValue("ItemSeparator"), repItems.ItemSeparator);
        }
        set
        {
            SetValue("ItemSeparator", value);
            repItems.ItemSeparator = value;
        }
    }

    #endregion


    #region "Map properties"

    /// <summary>
    /// Gets or sets the latitude of of the center of the map.
    /// </summary>
    public double Latitude
    {
        get
        {
            return ValidationHelper.GetDouble(GetValue("Latitude"), 0, "en-us");
        }
        set
        {
            SetValue("Latitude", value);
        }
    }


    /// <summary>
    /// Gets or sets the longitude of of the center of the map.
    /// </summary>
    public double Longitude
    {
        get
        {
            return ValidationHelper.GetDouble(GetValue("Longitude"), 0, "en-us");
        }
        set
        {
            SetValue("Longitude", value);
        }
    }


    /// <summary>
    /// Gets or sets the scale of the map.
    /// </summary>
    public int Scale
    {
        get
        {
            return ValidationHelper.GetInteger(GetValue("Scale"), 7);
        }
        set
        {
            SetValue("Scale", value);
        }
    }


    /// <summary>
    /// Gets or sets the scale of the map when zoomed (after marker click event).
    /// </summary>
    public int ZoomScale
    {
        get
        {
            return ValidationHelper.GetInteger(GetValue("ZoomScale"), 10);
        }
        set
        {
            SetValue("ZoomScale", value);
        }
    }


    /// <summary>
    /// Gets or sets the latitude of the center of the map.
    /// </summary>
    public String LatitudeField
    {
        get
        {
            return ValidationHelper.GetString(GetValue("LatitudeField"), "");
        }
        set
        {
            SetValue("LatitudeField", value);
        }
    }


    /// <summary>
    /// Gets or sets the longitude of the center of the map.
    /// </summary>
    public String LongitudeField
    {
        get
        {
            return ValidationHelper.GetString(GetValue("LongitudeField"), "");
        }
        set
        {
            SetValue("LongitudeField", value);
        }
    }


    /// <summary>
    /// Gets or sets the tool tip text field (filed for markers tool tip text).
    /// </summary>
    public String ToolTipField
    {
        get
        {
            return ValidationHelper.GetString(GetValue("ToolTipField"), "");
        }
        set
        {
            SetValue("ToolTipField", value);
        }
    }


    /// <summary>
    ///  Gets or sets the Google Maps Key, default is key for localhost
    /// </summary>
    public string GoogleMapsKey
    {
        get
        {
            return ValidationHelper.GetString(GetValue("GoogleMapsKey"), "");
        }
        set
        {
            SetValue("GoogleMapsKey", value);
        }
    }


    /// <summary>
    /// Gets or sets the width of the map
    /// </summary>
    public int Width
    {
        get
        {
            return ValidationHelper.GetInteger(GetValue("Width"), 400);
        }
        set
        {
            SetValue("Width", value);
        }
    }


    /// <summary>
    /// Gets or sets the height of the map
    /// </summary>
    public int Height
    {
        get
        {
            return ValidationHelper.GetInteger(GetValue("Height"), 400);
        }
        set
        {
            SetValue("Height", value);
        }
    }


    /// <summary>
    /// Gets or sets the value that indicates whether OverviewMapControl is displayed
    /// </summary>
    public bool ShowOverviewMapControl
    {
        get
        {
            return ValidationHelper.GetBoolean(GetValue("ShowOverviewMapControl"), true);
        }
        set
        {
            SetValue("ShowOverviewMapControl", value);
        }
    }


    /// <summary>
    /// Gets or sets the value that indicates whether LargeMapControl is displayed
    /// </summary>
    public bool ShowLargeMapControl
    {
        get
        {
            return ValidationHelper.GetBoolean(GetValue("ShowLargeMapControl"), true);
        }
        set
        {
            SetValue("ShowLargeMapControl", value);
        }
    }


    /// <summary>
    /// Gets or sets the value that indicates whether MapTypeControl is displayed
    /// </summary>
    public bool ShowMapTypeControl
    {
        get
        {
            return ValidationHelper.GetBoolean(GetValue("ShowMapTypeControl"), true);
        }
        set
        {
            SetValue("ShowMapTypeControl", value);
        }
    }


    /// <summary>
    /// Detail mode
    /// </summary>
    private bool DetailMode
    {
        get
        {
            if (mDetailMode == null)
            {
                // If this Document type is one of the specified, then we are in detail mode
                mDetailMode = ClassNames.ToLower().Contains(CMSContext.CurrentPageInfo.ClassName.ToLower());
            }

            if (mDetailMode == true)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
    }

    #endregion


    protected override void OnLoad(EventArgs e)
    {
        base.OnLoad(e);

        lblError.Visible = false;

        // Get current domain name (for google key identification)
        string currentDomainWithPort = UrlHelper.GetFullDomain().ToLower();

        // Due to new design mode (with preview) we need to move map down for the user to be able to drag and drop the control
        if (CMSContext.ViewMode == ViewModeEnum.Design)
        {
            ltlDesign.Text = "<div style=\"width: 10px; height: 30px\"></div>";
        }
        else
        {
            ltlDesign.Text = "";
        }

        // Get the google map key based on current domainname
        if (!GoogleMapsKey.Contains("="))
        {
            // Backward compatibility - only one key without site specified
            mKey = GoogleMapsKey;
        }
        else
        {
            // Handle key=value pair input (domain_name1=google_key1;domain_name2=google_key2)
            string[] keys = GoogleMapsKey.Split(';');
            foreach (string key in keys)
            {
                int pos = key.IndexOf("=");
                if (pos > -1)
                {
                    // Get corrected domain name (without protocol and www)
                    string domainName = key.Substring(0, pos);
                    // If there is a match, use this key
                    if (domainName.ToLower() == currentDomainWithPort)
                    {
                        mKey = key.Substring(pos + 1);
                        break;
                    }
                }
            }
        }

        // If we haven't found google maps key specified, chceck default domains and keys
        if (string.IsNullOrEmpty(mKey))
        {
            if (currentDomainWithPort == "localhost")
            {
                // Key for localhost
                mKey = "ABQIAAAA6CWHzS_AvKkNGdl2T5_iTRT2yXp_ZAY8_ufC3CFXhHIE1NvwkxRKxBWw5YGND-_bBHylQnQu9RjDrQ";
            }
            else if (currentDomainWithPort == "127.0.0.1")
            {
                // Key for 127.0.0.1
                mKey = "ABQIAAAA6CWHzS_AvKkNGdl2T5_iTRRi_j0U6kJrkFvY4-OX2XYmEAa76BQoN60bWhOmIAZQQKSfUr4EYnNvxQ";
            }
            else
            {
                loadScripts = false;
                repItems.StopProcessing = true;
                // Write instructions to user
                ltlDesign.Text += "You haven't specified Google Maps API Key for your domain. Go to <a href=\"http://code.google.com/apis/maps/signup.html\" target=\"_blank\">http://code.google.com/apis/maps/signup.html</a> and sign up for the key.";
                return;
            }
        }
    }


    /// <summary>
    /// Content loaded event handler
    /// </summary>
    public override void OnContentLoaded()
    {
        base.OnContentLoaded();
        SetupControl();
    }


    /// <summary>
    /// Initializes the control properties
    /// </summary>
    protected void SetupControl()
    {
        if (StopProcessing)
        {
            repItems.StopProcessing = true;
        }
        else
        {
            repItems.ControlContext = ControlContext;

            // Document properties
            repItems.CacheItemName = CacheItemName;
            repItems.CacheDependencies = CacheDependencies;
            repItems.CacheMinutes = CacheMinutes;
            repItems.CheckPermissions = CheckPermissions;
            repItems.ClassNames = ClassNames;
            repItems.CombineWithDefaultCulture = CombineWithDefaultCulture;
            repItems.CultureCode = CultureCode;
            repItems.MaxRelativeLevel = MaxRelativeLevel;
            repItems.OrderBy = OrderBy;
            repItems.SelectTopN = SelectTopN;
            repItems.SelectOnlyPublished = SelectOnlyPublished;
            repItems.FilterOutDuplicates = FilterOutDuplicates;

            repItems.Path = Path;

            repItems.SiteName = SiteName;
            repItems.WhereCondition = WhereCondition;

            // Relationships
            repItems.RelatedNodeIsOnTheLeftSide = RelatedNodeIsOnTheLeftSide;
            repItems.RelationshipName = RelationshipName;
            repItems.RelationshipWithNodeGuid = RelationshipWithNodeGUID;

            // Transformation properties
            repItems.TransformationName = TransformationName;
            repItems.AlternatingTransformationName = AlternatingTransformationName;

            // Public properties
            repItems.HideControlForZeroRows = HideControlForZeroRows;
            repItems.ZeroRowsText = ZeroRowsText;
            repItems.ItemSeparator = ItemSeparator;

            repItems.NestedControlsID = NestedControlsID;
        }
    }


    /// <summary>
    /// OnPreRender
    /// </summary>
    protected override void OnPreRender(EventArgs e)
    {
        base.OnPreRender(e);

        Visible = repItems.Visible;

        if (!StopProcessing)
        {
            if (loadScripts)
            {
                // Add Google map scrip declaration
                ltlBefore.Text = "<script type=\"text/javascript\">\n//<![CDATA[\nvar map;\n";

                // Add function for creating markers
                ltlBefore.Text += "function createMarker(point, content, cap) {\n" +
                    // " // marker options object\n" +
                          " var opt = new Object();\n" +
                          " opt.title = cap;\n" +
                          " var marker = new GMarker(point, opt);  \n" +
                    //  " // add click event to marker\n" +
                          " GEvent.addListener(marker, \"click\", function() {\n" +
                          "  map.setCenter(point, " + ZoomScale + ");\n" +
                          "  marker.openInfoWindowHtml(content);\n" +
                          " });\n" +
                          " return marker;\n" +
                          "}\n";

                // Create MapLoad function
                ltlBefore.Text += "function MapLoad() {\n" +
                    // "// Set width and height\n" +
                          "document.getElementById(\"map\").style.width=\"" + Width + "px\";\n" +
                          "document.getElementById(\"map\").style.height=\"" + Height + "px\";\n" +
                    // "// Set div which will contain map\n" +
                          "map = new GMap2(document.getElementById(\"map\"));\n" +
                    // "// Set default position\n" +
                          "map.setCenter(new GLatLng(" + Latitude.ToString().Replace(",", ".") + ", " + Longitude.ToString().Replace(",", ".") + "), " + Scale + ");\n";

                // Register scripts
                Page.ClientScript.RegisterClientScriptBlock(typeof(string), "googleMapScript", "<script src=\"http://maps.google.com/maps?file=api&amp;v=2.61&amp;key=" + mKey + "\" type=\"text/javascript\"></script>");
                Page.ClientScript.RegisterStartupScript(typeof(string), "googleMapLoadInitial", ScriptHelper.GetScript("" +
                         "if ( window.onload != null ) { var oldOnload = window.onload; \n" +
                         "window.onload = function ( e ) { oldOnload( e );	MapLoad();	}}" +
                         "else { window.onload = MapLoad; } \n"));


                // Add controls to map
                if (ShowLargeMapControl)
                {
                    ltlBefore.Text += "map.addControl(new GLargeMapControl());\n";
                }
                if (ShowMapTypeControl)
                {
                    ltlBefore.Text += "map.addControl(new GMapTypeControl());\n";
                }
                if (ShowOverviewMapControl)
                {
                    ltlBefore.Text += "map.addControl(new GOverviewMapControl());\n";
                }

                ltlAfter.Text += "}\n//]]>\n</script>\n";
            }
        }
        else
        {
            Visible = false;
        }
    }


    /// <summary>
    /// Repair input string (remove forbiden characters between macros '##TR##' and '##TRE##')
    /// </summary>
    private static string RepairInputString(string input)
    {
        string inputText = input;

        while ((inputText.IndexOf("##TR##") > 0) && (inputText.IndexOf("##TRE##") > 0))
        {
            int firstIndex = inputText.IndexOf("##TR##");
            int lastIndex = inputText.IndexOf("##TRE##") + 7;

            string sub = inputText.Substring(firstIndex, lastIndex - firstIndex);
            sub = sub.Replace("\"", "\\\"").Replace("\n", " ").Replace("\r", "").Replace("##TR##", "").Replace("##TRE##", "").Trim();
            inputText = inputText.Remove(firstIndex, lastIndex - firstIndex);
            inputText = inputText.Insert(firstIndex, sub);
        }

        return inputText;
    }


    /// <summary>
    /// Item databound
    /// </summary>
    protected void repItems_ItemDataBound(object sender, RepeaterItemEventArgs e)
    {
        if ((LatitudeField.Trim() != "") && (LongitudeField.Trim() != ""))
        {
            try
            {
                DataRow dr = e.Item.DataItem as DataRow;

                if (dr == null)
                {
                    DataRowView dv = e.Item.DataItem as DataRowView;
                    if (dv != null)
                    {
                        dr = dv.Row;
                    }
                }

                if (dr != null)
                {
                    // Get correct values from DataSet (replace decimal dash to dot)
                    string lLatitude = dr[LatitudeField].ToString().Replace(",", ".");
                    string lLongitude = dr[LongitudeField].ToString().Replace(",", ".");
                    string tooltip = "";

                    int docID = ValidationHelper.GetInteger(dr["DocumentID"], 0);

                    if (!String.IsNullOrEmpty(ToolTipField))
                    {
                        tooltip = ValidationHelper.GetString(dr[ToolTipField], "");
                    }


                    e.Item.Controls.AddAt(0, new LiteralControl("var point = new GLatLng(" + lLatitude + ", " + lLongitude + ");\ns = \"##TR##"));
                    e.Item.Controls.Add(new LiteralControl("##TRE##\";\n var marker = createMarker(point, s, '" + tooltip + "');\n map.addOverlay(marker);\n"));


                    // Zoom on curent marker if we are in detailed mode
                    if (DetailMode && docID == CMSContext.CurrentDocument.DocumentID)
                    {
                        e.Item.Controls.Add(new LiteralControl("map.setCenter(point, " + ZoomScale + ");\nmarker.openInfoWindowHtml(s);\n"));
                    }
                }
            }
            catch (Exception ex)
            {
                lblError.Visible = true;
                lblError.Text += ex.ToString();
            }
        }
    }


    /// <summary>
    /// Reload data
    /// </summary>
    public override void ReloadData()
    {
        base.ReloadData();

        SetupControl();
        repItems.ReloadData(true);
    }


    /// <summary>
    /// Render override
    /// </summary>
    protected override void Render(HtmlTextWriter writer)
    {
        if (StopProcessing)
        {
            base.Render(writer);
        }
        else
        {
            StringBuilder sb = new StringBuilder();
            Html32TextWriter mwriter = new Html32TextWriter(new StringWriter(sb));
            base.Render(mwriter);

            outputHtml = RepairInputString(sb.ToString());
            writer.Write(outputHtml);
        }
    }


    /// <summary>
    /// Clear cache.
    /// </summary>
    public override void ClearCache()
    {
        repItems.ClearCache();
    }
}
